Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Written by Array Alchemist
LeetCode wizard with 75 conquered challenges under my belt.
Turning algorithm nightmares into "Aha!" moments, one explanation at a time.
Join me to level up your coding skills – from interviews to real-world application!
You are climbing a staircase. It takes n steps to reach the top.
Each time you can either climb 1 or 2 steps. In how many distinct ways can you climb to the top?
Example 1:
Example 2:
What is subproblem here?
- At each step we can take either 1 or 2 steps
- So, we can break it down into subproblems of taking 1 step and 2 steps
But notice, at 2 we have 2 ways to reach 2, so we can add that to 3
and get 3 ways to reach 3
To recognise characteristics for using dynamic programming to solve a problem:
1. Overlapping Subproblems:
Notice that the number of distinct ways to reach the current step depends on the number of distinct ways to reach the previous steps.
For example, to reach step i, you can either come from step i-1 by taking a single step or come from step i-2 by taking two steps.
2. Optimal Substructure:
The optimal solution for reaching the i-th step can be constructed from
the optimal solutions of the previous steps.
n+1 because we need to account for the 0th step as well.
Since the steps are numbered from 1 to n, we need an array of size n+1 to store the number of distinct ways to reach each step.
This is a Dynamic programming problem. Which means we can look for
Basically a repeated sub problems if solved can solve the main problem as a whole.
For example, if we know how many steps it can take to get to
<__top__>
|
--------<last step i.e prev from top> A
|
-------<2nd last step i.e prev from A> B
|
At this point if we know how many ways there are to get to A and B, then we can easily calculate it form top i.e to finish climbing the stairs.
Similarly, To get to A,
if we knew how many ways to get to Prev of A + prev of Previous of A, we can calculate , how many ways there are to get to A.
In a way we can see our recurrence relations as:
Ways to get to A = number of ways @ [A - 1] + number of ways @[A -2]
So using this formula we can easily calculate. Number of minimum ways to get to the top
Now let's see how we can solve this problem:
0 1 2 3 4
cost = [20 15 30 5]
minCost to reach @ 4 = minCost of(2, 3)
minCost(n)
/ \
minCost(n-1) minCost(n-2)
do we want both of them? we want the min between these two values
Note that,
minCost of reaching these steps includes the cost of the step itself.
recurrence relation Math.min(minCost(n-1), minCost(n - 2)) + cost(n)
if we observe this, we can optimize this further down where we don't need any array to store any value:
Time Complexity = O(N)
Space Complexity = O(1)
When submitted to leet code this is the result: